module Gleis
  module CLI
    # Add-ons-related CLI commands
    class Addon < Thor
      class_option :app, aliases: :'-a', type: :string, default: Utils.app_name, desc: 'Name of application'

      desc 'add ADDON', 'Add add-on to app'
      def add(name)
        Gleis::Addon.add(options[:app], name)
      end

      desc 'list', 'List available add-ons on Gleis and add-ons used by app'
      def list
        Gleis::Addon.list(options[:app])
      end

      desc 'remove ADDON', 'Remove add-on from app'
      def remove(name)
        Gleis::Addon.remove(options[:app], name)
      end
    end
  end
end
