module Gleis
  module CLI
    # Authentication-related CLI commands
    class Auth < Thor
      desc 'key COMMAND', 'Manage git public keys: add, list, remove'
      subcommand 'key', CLI::AuthKey

      desc 'login USERNAME [PASSWORD]', 'Login into Gleis'
      option :skip_keygen, aliases: :'-s', type: :boolean, default: false
      def login(username, password = nil)
        Authentication.login(username, password, options[:skip_keygen])
      end

      desc 'logout', 'Logout of Gleis'
      def logout
        Authentication.logout
      end

      desc 'register EMAIL', 'Register for a free Gleis account'
      def register(email)
        Authentication.register(email)
      end

      desc 'whoami', 'Info on current login'
      def whoami
        Authentication.whoami
      end
    end
  end
end
