module Gleis
  module CLI
    # Git authentication key related CLI commands
    class AuthKey < Thor
      desc 'add FILENAME [KEYNAME]', 'Add SSH public key file for git authentication'
      def add(key_file, key_name = nil)
        Gleis::AuthKey.add(key_file, key_name)
      end

      desc 'list', 'List all SSH public keys allowed for git authentication'
      def list
        Gleis::AuthKey.list
      end

      desc 'remove KEYNAME', 'Remove SSH public key from git authentication'
      def remove(key_name)
        Gleis::AuthKey.remove(key_name)
      end
    end
  end
end
