module Gleis
  module CLI
    # Domain-related CLI commands
    class Domain < Thor
      class_option :app, aliases: :'-a', type: :string, default: Utils.app_name, desc: 'Name of application'

      desc 'add DOMAIN', 'Add domain name to app'
      def add(name)
        Gleis::Domain.add(options[:app], name)
      end

      desc 'list', 'List existing domain names for app'
      def list
        Gleis::Domain.list(options[:app])
      end

      desc 'remove DOMAIN', 'Remove domain name from app'
      def remove(name)
        Gleis::Domain.remove(options[:app], name)
      end
    end
  end
end
