module Gleis
  module CLI
    # Add-ons-related CLI commands
    class Scheduler < Thor
      class_option :app, aliases: :'-a', type: :string, default: Utils.app_name, desc: 'Name of application'

      desc 'add COMMAND', 'Add command to be scheduled for this app'
      option :frequency, aliases: :'-f', type: :string, required: true,
                         desc: 'Frequency to run job: 10minutes, hourly or daily'
      option :time, aliases: :'-t', type: :string,
                    desc: 'Time in HH:MM format to run a job for the hourly (e.g. :15) or daily (e.g. 23:30) frequency'
      def add(command)
        Gleis::Scheduler.add(options[:app], options[:frequency], options[:time], command)
      end

      desc 'list', 'List scheduled job for this app'
      def list
        Gleis::Scheduler.list(options[:app])
      end

      desc 'remove', 'Remove scheduled job from app'
      def remove
        Gleis::Scheduler.remove(options[:app])
      end
    end
  end
end
