module Gleis
  module CLI
    # Sharing-related CLI commands
    class Sharing < Thor
      class_option :app, aliases: :'-a', type: :string, default: Utils.app_name, desc: 'Name of application'

      desc 'add EMAIL ROLE', 'Allow user to access app (roles: collaborator, owner)'
      def add(email, role)
        Gleis::Sharing.add(options[:app], email, role)
      end

      desc 'list', 'Show access list of application'
      def list
        Gleis::Sharing.list(options[:app])
      end

      desc 'remove EMAIL', 'Remove user access to app'
      def remove(email)
        Gleis::Sharing.remove(options[:app], email)
      end
    end
  end
end
