module Gleis
  module CLI
    # Storage-related CLI commands
    class Storage < Thor
      class_option :app, aliases: :'-a', type: :string, default: Utils.app_name, desc: 'Name of application'

      desc 'add TYPE', 'Add storage to app'
      def add(type)
        Gleis::Storage.add(options[:app], type)
      end

      desc 'attach DIRECTORY', 'Attach storage to directory (e.g. /usr/src/app/public)'
      def attach(dir)
        Gleis::Storage.attach(options[:app], dir)
      end

      desc 'list', 'List available storage types'
      def list
        Gleis::Storage.list(options[:app])
      end

      desc 'sync DIRECTORY', 'Synchronise local directory to Gleis storage (from local to remote)'
      option :reverse, aliases: :'-x', type: :boolean, default: false,
                       desc: 'Reverse synchronisation (from remote to local)'
      def sync(dir)
        Gleis::Storage.sync(options[:app], dir, options[:reverse])
      end
    end
  end
end
