module Gleis
  # Global parameters of gleis gem and app config env variables
  class Config
    # Override default API URL if GLEIS_API_URL env variable is set
    API_URL = ENV['GLEIS_API_URL'].nil? ? 'https://api.basel.gleis.app/' : ENV['GLEIS_API_URL']
    API_VERSION = 'v0'.freeze
    SSH_KEY_FILE_BASE = File.join(Dir.home, '.ssh', 'gleis')
    TOKEN_FILE = File.join(Dir.home, '.gleis-token')

    def self.get_env_vars(app_name, token)
      body = API.request('get', "config/#{app_name}", token)
      abort("Failed to get app environment variables: #{body['message']}") if body['success'] != 1
      body
    end

    def self.get_env_var(app_name, token, var_name)
      body = API.request('get', "config/#{app_name}/#{var_name}", token)
      return body['data'] if body['success'] == 1
    end
  end
end
