require 'gleis'

module Gleis
  # This class defines all the main command-line interface commands for gleis
  class Main < Thor
    def self.exit_on_failure?
      true
    end

    desc 'login USERNAME', 'Login into Gleis'
    def login(username)
      Authentication.login(username)
    end

    desc 'register EMAIL', 'Register for a free Gleis account'
    def register(email)
      Authentication.register(email)
    end

    desc 'addon COMMAND', 'Manage add-ons: add, list, remove'
    subcommand 'addon', CLI::Addon

    desc 'app COMMAND', 'Manage applications: create, start, stop, logs, etc.'
    subcommand 'app', CLI::App

    desc 'auth COMMAND', 'Authentication commands: key, login, logout, whoami'
    subcommand 'auth', CLI::Auth

    desc 'db COMMAND', 'Manage databases: info, new, promote, psql, etc.'
    subcommand 'db', CLI::Db

    desc 'domain COMMAND', 'Manage domains: add, list, remove'
    subcommand 'domain', CLI::Domain

    desc 'mgmt COMMAND', 'Administration and management related commands'
    subcommand 'mgmt', CLI::Management

    desc 'scheduler COMMAND', 'Manage scheduled job: add, list, remove'
    subcommand 'scheduler', CLI::Scheduler

    desc 'sharing COMMAND', 'Manage collaboration: add, list, remove'
    subcommand 'sharing', CLI::Sharing

    desc 'storage COMMAND', 'Manage persistent storage: add, list, sync, etc.'
    subcommand 'storage', CLI::Storage
  end
end
