module Gleis
  # This class manages the authentication token granted from the API server
  class Token
    def self.save(token)
      abort('No tokens received.') unless token
      f = File.new(Config::TOKEN_FILE, 'w', 0o0640)
      f.write(token)
      f.close
    end

    def self.check
      return File.read(Config::TOKEN_FILE) if File.exist?(Config::TOKEN_FILE)

      abort('Not authenticated, please login first.')
    end

    def self.delete
      File.delete(Config::TOKEN_FILE) if File.exist?(Config::TOKEN_FILE)
    end
  end
end
